#ifndef VHTTPD_TLS_H
#define VHTTPD_TLS_H

#include <vhttpd/buffer.h>

typedef struct tls_ctx_t tls_ctx_t;
typedef struct tls_session_t tls_session_t;

tls_ctx_t *tls_ctx_new (const char *keyfile, const char *certfile);
void tls_ctx_delete (tls_ctx_t * c);

tls_session_t *tls_session_new (int, tls_ctx_t *);
int tls_session_send (tls_session_t *, const char *, size_t);
int tls_session_sendfile (tls_session_t *, int fd, size_t);
int tls_session_receive (tls_session_t *, buffer_t *);
void tls_session_delete (tls_session_t * s);

#endif
