#ifndef CHANNEL_PRIVATE_H
#define CHANNEL_PRIVATE_H

#include <vhttpd/buffer.h>

/* generic channel*/
struct channel_t
{
  struct channel_t *(*accept) (struct channel_t *);
  int (*send) (struct channel_t *, const char *, size_t);
  int (*sendfile) (struct channel_t *, int fd, size_t);
  int (*receive) (struct channel_t *, buffer_t *);
  void (*destroy) (struct channel_t *);

  int fd;
  char *remote_addr;
  int flags;
  int type;
};

void plain_channel_init (channel_t *c, int fd, char *remote_addr, int flags);
channel_t *plain_channel_accept (channel_t *);
int plain_channel_send (channel_t *, const char *, size_t);
int plain_channel_sendfile (channel_t *, int, size_t);
int plain_channel_receive (channel_t *, buffer_t *);
void destroy_plain_channel (channel_t *);

#endif /* CHANNEL_PRIVATE_H */
