#include <vhttpd/channel.h>
#include <vhttpd/http_connection.h>

#include <vhttpd/http_client.h>

retcode_t
request_server(channel_t *ch, const message_t *request, message_t **response)
{
  connection_t *conn;
  retcode_t retcode;

  if (!ch || !request || !response)
    return bad_request;

  conn = connection_new(ch,NULL,NULL);

  if (connection_send_message(conn,request)){
    retcode=bad_request;
  }
  else {
    *response = create_response_message(unfinished);
    while ((retcode = connection_receive_message(conn,*response)) == unfinished) ; /* try until success */
  }
  destroy_channel (connection_get_channel(conn));
  connection_delete (conn);
  return retcode;
}

retcode_t
request_inet_server(const char *addr, const char* port, const message_t *request, message_t **response)
{
  return request_server(create_inet_channel(addr,port,C_SO_DEFAULT_CLIENT),request,response);
}

retcode_t
request_unix_server(const char *path, const message_t *request, message_t **response)
{
  return request_server(create_unix_channel(path,C_SO_DEFAULT_CLIENT),request,response);
}
